import _default from 'object-assign'
var hasSymbol = typeof Symbol === 'function' && Symbol.for
var REACT_CONTEXT_TYPE = hasSymbol ? Symbol.for('react.context') : 0xeace
export var preload = function preload(element) {
  return new Promise(function(resolve, reject) {
    var recursePreload = function recursePreload(
      rootElement,
      rootLegacyContext,
      rootNewContext,
      loadRoot
    ) {
      if (rootLegacyContext === void 0) {
        rootLegacyContext = {}
      }

      if (rootNewContext === void 0) {
        rootNewContext = new Map()
      }

      if (loadRoot === void 0) {
        loadRoot = true
      }

      var loading = []

      var recurse = function recurse(element, legacyContext, newContext) {
        if (!element) return

        if (Array.isArray(element)) {
          element.forEach(function(item) {
            return recurse(item, legacyContext, newContext)
          })
          return
        }

        if (
          element.type &&
          (element.type.$$typeof === REACT_CONTEXT_TYPE ||
            typeof element.type === 'function')
        ) {
          var props = _default({}, element.type.defaultProps, element.props)

          if (element.type.$$typeof === REACT_CONTEXT_TYPE) {
            var value = element.type._currentValue
            var Provider = element.type._context
              ? element.type._context.Provider
              : element.type.Provider
            if (newContext && newContext.has(Provider))
              value = newContext.get(Provider)
            recurse(element.props.children(value), legacyContext, newContext)
          } else if (
            element.type.prototype &&
            (element.type.prototype.isReactComponent ||
              element.type.prototype.isPureReactComponent)
          ) {
            var instance = new element.type(props, legacyContext)
            instance.props = instance.props || props
            instance.state = instance.state || null

            instance.setState = function(newState) {
              if (typeof newState === 'function')
                newState = newState(instance.state, instance.props)
              instance.state = _default({}, instance.state, newState)
            }

            if (instance.componentWillMount) instance.componentWillMount()
            if (instance.getChildContext)
              legacyContext = _default(
                {},
                legacyContext,
                instance.getChildContext()
              )
            if (
              instance.constructor.name === 'GraphQLQuery' &&
              element.props.loadOnMount &&
              (element !== rootElement || loadRoot)
            )
              loading.push(
                instance.load().then(function() {
                  return recursePreload(
                    element,
                    legacyContext,
                    newContext,
                    false
                  )
                })
              )
            else recurse(instance.render(), legacyContext, newContext)
          } else recurse(element.type(props), legacyContext, newContext)
        } else if (element.props && element.props.children) {
          if (element.type._context) {
            newContext = new Map(newContext)
            newContext.set(element.type, element.props.value)
          }

          recurse(element.props.children, legacyContext, newContext)
        }
      }

      recurse(rootElement, rootLegacyContext, rootNewContext)
      return Promise.all(loading).then(function() {})
    }

    recursePreload(element)
      .then(resolve)
      .catch(reject)
  })
}
